package cn.timer.api.bean.qyzx;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
 
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import cn.timer.api.bean.yggl.YgglMainEmp;
import cn.timer.api.dto.login.QysDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2019-11-11
*/
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder(toBuilder=true)
@ApiModel("员工登录表")
public class QyzxEmpLogin extends Model<QyzxEmpLogin> {

	private static final long serialVersionUID = 3545665863196016627L;

    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号",example="101")
    private Integer id;
    
	@ApiModelProperty(value="当前企业id 当前企业id",example="101")
    private Integer orgId;
	
	@ApiModelProperty(value = "用户名", example = "用户名")
	private String username;
    
	@ApiModelProperty(value="手机号 ",example=" 用户名")
	private String phone;
	 
	@ApiModelProperty(value="密码 ",example="密码")
    private String pw;
    
	@ApiModelProperty(value="账户状态  0：关闭；1：正常",example="101")
    private Integer sts;
    
	@ApiModelProperty(value="邮箱地址 ",example="邮箱地址")
    private String email;
	
	@ApiModelProperty(value="邮箱状态 ",example="0-未激活 1-已绑定")
    private Integer emailStatus;
    
	@ApiModelProperty(value="微信openid ",example="微信openid")
    private String openid;
    
    
	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value="注册时间 ",example="注册时间")
    private Date regTime;
	
	@ApiModelProperty(value="头像地址 ",example="http://asd")
    private String headUrl;
	
	@TableField(exist = false)
	@ApiModelProperty(value="IP ",example="101.101.101.101")
	private String ip;
	
	@TableField(exist = false)
	@ApiModelProperty(value="验证码 ",example="666666")
	private Integer code;

	@ApiModelProperty(value="权限 ",example="0,1,2")
	@TableField(exist = false)
	private List<String> menus;
	
	@TableField(exist = false)
	@Builder.Default
	private List<QysDto> qys = new ArrayList<QysDto>();  
    
	@TableField(exist = false)
	private YgglMainEmp ygglMainEmp;
}