package cn.timer.api.dto.spmk;

import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import cn.timer.api.config.exception.ValidationMsg;
import cn.timer.api.utils.Page;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MySummaryQueryDto extends Page{

	private Integer orgCode;
	
	private Integer empNum;
	
	@ApiModelProperty(value = "关键字 标题/审批人名称/审批总汇id", example = "请假")
	private String query;
	
	@ApiModelProperty(value = "状态 0审批中 1审批撤销  2审批通过/审批完成 3审批拒绝", example = "0")
	private Integer sts;
	
	@ApiModelProperty(value = "开始时间 ", example = "2000-10-10 10:10:10")
	private String startTime;
	
	@ApiModelProperty(value = "结束时间 ", example = "2020-10-10 10:10:10")
	private String endTime;
	
	@NotNull(message = ValidationMsg.NOTNULL)
	@DecimalMax(value = "2",message = ValidationMsg.DECIMALMAX+" 只能为 0我发起的 1抄送我的 2我审批的")
	@DecimalMin(value = "0",message = ValidationMsg.DECIMALMIN+" 只能为 0我发起的 1抄送我的 2我审批的")
	@ApiModelProperty(value = "0我发起的 1抄送我的 2我审批的", example = "0")
	private Integer type;
	
}
